

namespace QPG.Demo.Components
{
	using System;


	public class Product
	{
		private int _price;
		private int _stocks;

		private string  _name;

		public Product()
		{
			_name="";
			_price=0;
			_stocks=0;
			Console.WriteLine("call Product()");

		}
		public Product(string name,int price,int num) {
			_name=name;
			_price=price;
			_stocks=num;
			Console.WriteLine(string.Format("Product({0},{1},{2})",name,price,num));
		}

		public virtual string Name{
			get{return _name;}
		}
		public virtual int Price{
			get{return _price;}
		}
		public virtual int Stocks{
			get{return _stocks;}
		}

		public virtual void setPrice(int newPrice) {
			_price=newPrice;
		}

		public virtual void outStock(int num) {
			int temp=_stocks-num;
			if(temp<0) throw new Exception("stock lack!");
			_stocks=temp;
		}
		
	}
}
