using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using QPG.UIP;

namespace QPG.WinTest
{
	/// <summary>
	/// Form1 ժҪ˵
	/// </summary>
	public class Form1 : System.Windows.Forms.Form,IMainForm
	{
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.Panel panel1;
		public static PluginService Plugins=new PluginService();
		private QPG.UIP.Actions.ActionList actionList1;
		private QPG.UIP.Actions.Action action1;
		private QPG.UIP.Actions.Action action2;
		private System.Windows.Forms.Button button1;
		private System.Windows.Forms.Button button2;
		private System.Windows.Forms.MainMenu mainMenu1;
		private System.Windows.Forms.MenuItem menuItem1;
		private System.Windows.Forms.MenuItem menuItem2;
		private System.Windows.Forms.MenuItem menuItem3;
		private System.Windows.Forms.CheckBox checkBox1;
		protected IPlugin selectedPlugin;

		public Form1()
		{
			//
			// Windows ֧
			//
			InitializeComponent();
			Plugins.MainForm=this;
		
			action1.Tag="Demo.UIC.Plugin1";
			action2.Tag="Demo.UIC.Plugin2";
			action1.Execute+=new EventHandler(runAction);
			action2.Execute+=new EventHandler(runAction);

			}
		private void runAction(object sender, System.EventArgs e) {
			QPG.UIP.Actions.Action a=sender as QPG.UIP.Actions.Action;
		
			if(getPrivilegeByUser("admin", a.Tag.ToString())==Privilege.None) return;
		
			selectedPlugin=Plugins.FindPlugin(a.Tag.ToString() );
			panel1.Controls.Clear();
			selectedPlugin.MainInterface.Enabled=action1.Enabled;
				panel1.Controls.Add(selectedPlugin.MainInterface);
				selectedPlugin.MainInterface.Dock=DockStyle.Fill;
		

		}

		/// <summary>
		/// ʹõԴ
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows ɵĴ
		/// <summary>
		/// ֧ķ - Ҫʹô༭޸
		/// ˷ݡ
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			this.panel1 = new System.Windows.Forms.Panel();
			this.actionList1 = new QPG.UIP.Actions.ActionList(this.components);
			this.action1 = new QPG.UIP.Actions.Action(this.components);
			this.action2 = new QPG.UIP.Actions.Action(this.components);
			this.button1 = new System.Windows.Forms.Button();
			this.button2 = new System.Windows.Forms.Button();
			this.menuItem2 = new System.Windows.Forms.MenuItem();
			this.menuItem3 = new System.Windows.Forms.MenuItem();
			this.mainMenu1 = new System.Windows.Forms.MainMenu();
			this.menuItem1 = new System.Windows.Forms.MenuItem();
			this.checkBox1 = new System.Windows.Forms.CheckBox();
			this.SuspendLayout();
			// 
			// panel1
			// 
			this.panel1.Location = new System.Drawing.Point(8, 64);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(512, 192);
			this.panel1.TabIndex = 2;
			// 
			// actionList1
			// 
			this.actionList1.Actions.AddRange(new QPG.UIP.Actions.Action[] {
																			   this.action1,
																			   this.action2});
			this.actionList1.ImageList = null;
			this.actionList1.ShowTextOnToolBar = false;
			this.actionList1.Tag = null;
			// 
			// action1
			// 
			this.action1.Checked = true;
			this.action1.Enabled = false;
			this.action1.Hint = null;
			this.action1.Shortcut = System.Windows.Forms.Shortcut.None;
			this.action1.Tag = null;
			this.action1.Text = "";
			this.action1.Visible = true;
			// 
			// action2
			// 
			this.action2.Checked = false;
			this.action2.Enabled = true;
			this.action2.Hint = null;
			this.action2.Shortcut = System.Windows.Forms.Shortcut.None;
			this.action2.Tag = null;
			this.action2.Text = "ѡ";
			this.action2.Visible = true;
			// 
			// button1
			// 
			this.actionList1.SetAction(this.button1, this.action1);
			this.button1.Location = new System.Drawing.Point(56, 8);
			this.button1.Name = "button1";
			this.button1.Size = new System.Drawing.Size(88, 23);
			this.button1.TabIndex = 1;
			this.button1.Text = "";
			// 
			// button2
			// 
			this.actionList1.SetAction(this.button2, this.action2);
			this.button2.Location = new System.Drawing.Point(280, 8);
			this.button2.Name = "button2";
			this.button2.Size = new System.Drawing.Size(88, 23);
			this.button2.TabIndex = 3;
			this.button2.Text = "ѡ";
			// 
			// menuItem2
			// 
			this.actionList1.SetAction(this.menuItem2, this.action1);
			this.menuItem2.Checked = true;
			this.menuItem2.Enabled = false;
			this.menuItem2.Index = 0;
			this.menuItem2.Text = "";
			// 
			// menuItem3
			// 
			this.actionList1.SetAction(this.menuItem3, this.action2);
			this.menuItem3.Index = 1;
			this.menuItem3.Text = "ѡ";
			// 
			// mainMenu1
			// 
			this.mainMenu1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem1});
			// 
			// menuItem1
			// 
			this.menuItem1.Index = 0;
			this.menuItem1.MenuItems.AddRange(new System.Windows.Forms.MenuItem[] {
																					  this.menuItem2,
																					  this.menuItem3});
			this.menuItem1.Text = "Menu";
			// 
			// checkBox1
			// 
			this.checkBox1.Location = new System.Drawing.Point(56, 32);
			this.checkBox1.Name = "checkBox1";
			this.checkBox1.TabIndex = 4;
			this.checkBox1.Text = "enable";
			this.checkBox1.Click += new System.EventHandler(this.checkBox1_Click);
				// 
			// Form1
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(6, 14);
			this.ClientSize = new System.Drawing.Size(528, 273);
			this.Controls.Add(this.checkBox1);
			this.Controls.Add(this.button2);
			this.Controls.Add(this.panel1);
			this.Controls.Add(this.button1);
			this.Menu = this.mainMenu1;
			this.Name = "Form1";
			this.Text = "Form1";
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// Ӧóڵ㡣
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new Form1());
		}
		#region IMainForm Ա

		public string CurUserID {
			get {
				// TODO:   Form1.CurUserID getter ʵ
				return "admin";
			}
		}

		public object getCookie(string name) {
			// TODO:   Form1.getCookie ʵ
			return name;
		}

		public void addCookie(string name, object obj) {
			// TODO:   Form1.addCookie ʵ
		}

		public QPG.UIP.Privilege getPrivilegeByUser(string uid, string cmdName) {
			// TODO:   Form1.getPrivilegeByUser ʵ
			return  QPG.UIP.Privilege.Full;
		}

		public void showStatus(string msg) {
			MessageBox.Show(msg);
		}

		public void showHelp(string help) {
			// TODO:   Form1.showHelp ʵ
		}

		public void showNotify(string title, string msg) {
			MessageBox.Show(msg);
		}

		#endregion

		

		private void checkBox1_Click(object sender, System.EventArgs e) {
			action1.Enabled=checkBox1.Checked;
			if(selectedPlugin!=null) selectedPlugin.MainInterface.Enabled=action1.Enabled;
				
		}
	}
}
