

namespace QPG.Demo.Components {
	using System;
	using System.Threading;

	public enum Role :int {Manager,Employee,Other};
	public class SaleMgr {
		private Role _curUserRole;
		
		public  SaleMgr() {
			_curUserRole=Role.Other;

		}
		
		public  SaleMgr(Role r) {
			_curUserRole=r;
		}
		public virtual Role CurUserRole{
			get{return _curUserRole;}
			set{_curUserRole=value;}
		}
		public virtual void acceptOrder(Product prd,int num) {
			prd.outStock(num);
			System.Threading.Thread.Sleep(15);
		}
		public virtual void adjustPrice(Product prd,int newPrice) {
			prd.setPrice(newPrice);
			System.Threading.Thread.Sleep(10);
		}
	}
}
